<template>
    <div class="all-delivery-rectangle">
        <div class="p-3">
            <h3><strong>Livraison</strong></h3>
            <hr class="lign">
            <div>
                <div class="col-12" v-for="delivery in deliveries" :key="delivery._id">
                    <b-row>
                        <b-col cols="9">
                    <div v-if="delivery.deliverer == null || delivery.deliverer == user.id || delivery.status !== 101" class="delivery-rectangle row">  
                        <p class="command text-center"> Commande : {{ delivery.command }} </p>
                        <p class="text-center" v-if="delivery.deliverer == user.id"> Statut : En cours de livraison </p>
                        <p class="text-center" v-else> Statut : Disponible </p>
                    </div>
                        </b-col>
                        <b-col class="valid-button" cols="3">
                    <b-button v-if="delivery.deliverer == null" v-on:click="handle(delivery._id)" variant="outline-secondary">
                        <div style="font-size: 14px"><b>Traiter</b></div>
                    </b-button>
                    <b-button v-if="delivery.status == 0 && delivery.deliverer == user.id" v-on:click="finish(delivery._id)" variant="outline-secondary">
                        <div style="font-size: 14px"><b>Finir</b></div>
                    </b-button>
                    </b-col>
                    </b-row>
                </div> 
            </div>
            <b-alert :show="handleAlert" variant="info" @dismissed="handleAlert=0" @dismiss-count-down="handleCountDown"> Commande Acceptée ! </b-alert>
            <b-alert :show="finishAlert" variant="success" @dismissed="finishAlert=0" @dismiss-count-down="finishCountDown"> Commande Délivrée ! </b-alert>
        </div>
    </div>
</template>

<script>
import Vue from 'vue';
import { mapActions, mapGetters } from 'vuex';
export default Vue.extend({
  name: 'DeliveriesComponent',

  data: () => ({
        user: {
            id: "",
        },
        handleAlertSecs: 5,
        handleAlert: 0,
        finishAlertSecs: 5,
        finishAlert: 0,
        body:{
            id: "",
            status: "",
        }
    }),

    computed: {
    ...mapGetters(['deliveries', '']),
  },

    methods: {
        ...mapActions(
            ["getDeliveriesList", 
            "getHandleDelivery",
            "putFinishDelivery"]
        ),

        handleCountDown(handleAlert) {
        this.handleAlert = handleAlert
        },

        finishCountDown(finish) {
        this.finishAlert = finish
        },

        handle(id) {
            this.handleAlert = this.handleAlertSecs
            this.getHandleDelivery(id)

        },
        finish(id) {
            this.finishAlert = this.finishAlertSecs
            this.body.id = id
            this.body.status = 101
            console.log(this.body)
            this.putFinishDelivery(this.body)
        },
    },

    created() {
        this.$store.dispatch('getDeliveriesList');
    },

    mounted() {
    if (localStorage.user) {
        this.user = JSON.parse(localStorage.user);
    }

  //mounted() {
    // Prendre le delivery.id pour l'envoyer récupérer la commande
    // Utiliser l'id de la commande pour récupérer le restaurant et l'utilisateur
    // Utiliser l'id du restaurant pour récupérer le nom du restaurant
    // Utiliser l'id du client pour récupérer NomPrénom + adresse
  }
});
</script>

<style scoped>

.all-delivery-rectangle {
    background-color: #FFF1D8;
	width:400px;
	height:720px;
    border-radius: 20px;
    margin-top: 10px;
    margin-left: 15px;
    margin: auto;
}

.lign{
    width:100%;
    color:black;
    background-color:black;
    height:2px;
    border-radius: 10px;
}

.delivery-rectangle {
    background-color: #FFFFFF;
	width:300px;
	height:100px;
    border-radius: 20px;
    margin-top: 10px;
}

.command{
    font-size: 20px;
    color: #000000;
}

.valid-button{
    margin-top: 10%;
}

</style>

